## deal.ii 9.5.1

=== CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------


##                                                                    ##
#            The cmake build system for the deal.II project            #
#                                                                      #
#   See doc/readme.html and doc/developers/cmake-internals.html for    #
#   further details on how to use the cmake build system of deal.II.   #
##                                                                    ##

########################################################################
#                                                                      #
#                            Configuration:                            #
#                                                                      #
########################################################################

#
# General configuration for cmake:
#
message(STATUS "This is CMake ${CMAKE_VERSION}")
message(STATUS "")

cmake_minimum_required(VERSION 3.13.4)
#
# We support all policy changes up to version 3.11.
#
cmake_policy(VERSION 3.13.4)

if(POLICY CMP0075)
  # Introduced in CMake 3.12: Use CMAKE_REQUIRED_LIBRARIES also in include
  # file checks. We set the policy to NEW explicitly in order to avoid
  # spurious configure warnings.
  cmake_policy(SET CMP0075 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/)

#
# Load all macros:
#
file(GLOB _macro_files "cmake/macros/*.cmake")
message(STATUS "Include ${CMAKE_SOURCE_DIR}/cmake/setup_external_macros.cmake")
include(${CMAKE_SOURCE_DIR}/cmake/setup_external_macros.cmake)
foreach(_file ${_macro_files})
  message(STATUS "Include ${_file}")
  include(${_file})
endforeach()

#
# Avoid verbose "Up-to-date" status information during installation:
#
set_if_empty(CMAKE_INSTALL_MESSAGE "LAZY")

#
# Check for the existence of various optional folders:
#
if(EXISTS ${CMAKE_SOURCE_DIR}/bundled/CMakeLists.txt)
  set(DEAL_II_HAVE_BUNDLED_DIRECTORY TRUE)
endif()

if(EXISTS ${CMAKE_SOURCE_DIR}/doc/CMakeLists.txt)
  set(DEAL_II_HAVE_DOC_DIRECTORY TRUE)
endif()

if(EXISTS ${CMAKE_SOURCE_DIR}/tests/CMakeLists.txt)
  set(DEAL_II_HAVE_TESTS_DIRECTORY TRUE)
endif()

#
# We have to initialize some cached variables before PROJECT is called, so
# do it at this point:
#
verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_cached_variables.cmake)

#
# Now, set the project and set up the rest:
#
project(deal.II CXX C)
enable_language_optional(Fortran)

verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_deal_ii.cmake)

verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_compiler_flags.cmake)

#
# Include information about bundled libraries:
#
if(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  verbose_include(${CMAKE_SOURCE_DIR}/bundled/setup_bundled.cmake)
endif()

#
# Run all system checks:
#
file(GLOB _check_files "cmake/checks/*.cmake")
list(SORT _check_files)
foreach(_file ${_check_files})
  verbose_include(${_file})
endforeach()

#
# Feature configuration:
#
file(GLOB _configure_files "cmake/configure/configure_*.cmake")
list(SORT _configure_files) # make sure to include in alphabetical order
foreach(_file ${_configure_files})
  verbose_include(${_file})
endforeach()

verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_finalize.cmake)

verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_cpack.cmake)
verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_custom_targets.cmake)

########################################################################
#                                                                      #
#                     Compilation and installation:                    #
#                                                                      #
########################################################################

message(STATUS "")
message(STATUS "Configuring done. Proceed to target definitions now.")

set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

add_subdirectory(cmake/scripts)
add_subdirectory(include)

if(DEAL_II_HAVE_DOC_DIRECTORY)
  add_subdirectory(doc) # has to be included after include
endif()

if(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  add_subdirectory(bundled)
endif()
add_subdirectory(source) # has to be included after bundled

add_subdirectory(cmake/config) # has to be included after source
add_subdirectory(examples)

add_subdirectory(contrib/utilities)

if(DEAL_II_HAVE_TESTS_DIRECTORY)
  add_subdirectory(tests)
endif()

add_subdirectory(contrib/python-bindings) # has to be included after tests

verbose_include(${CMAKE_SOURCE_DIR}/cmake/setup_write_config.cmake)

#
# And finally, print the configuration:
#
file(READ ${CMAKE_BINARY_DIR}/summary.log DEAL_II_LOG_SUMMARY)
message("${DEAL_II_LOG_SUMMARY}")

=== doc/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2022 by the deal.II Authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# Set up all necessary bits for the documentation
#
if(DEAL_II_COMPONENT_DOCUMENTATION)

  message(STATUS "")
  message(STATUS "Setting up documentation")

  add_subdirectory(news)
  add_subdirectory(doxygen)

  #
  # Install the static elements of the html documentation:
  #
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${DEAL_II_DOCHTML_RELDIR}
    COMPONENT documentation
    PATTERN "CMakeLists.txt" EXCLUDE
    PATTERN "doxygen" EXCLUDE
    PATTERN "news" EXCLUDE
    )

  message(STATUS "Setting up documentation - Done")
  message(STATUS "")

endif()

#
# Always install a minimalistic README and LICENSE file:
#

install(FILES
  ${CMAKE_SOURCE_DIR}/README.md
  ${CMAKE_SOURCE_DIR}/LICENSE.md
  DESTINATION ${DEAL_II_DOCREADME_RELDIR}
  COMPONENT library
  )

#
# Install summary.log an detailed.log
#

install(FILES
  ${CMAKE_BINARY_DIR}/summary.log
  ${CMAKE_BINARY_DIR}/detailed.log
  DESTINATION ${DEAL_II_DOCREADME_RELDIR}
  COMPONENT library
  )

#
# Add a dummy target to make documentation files known to IDEs.
#

file(GLOB _misc
  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen/headers/*.h
  )

add_library(doxygen_headers OBJECT ${_misc})
set_target_properties(doxygen_headers PROPERTIES LINKER_LANGUAGE C)

=== examples/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2022 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

if(DEAL_II_COMPONENT_EXAMPLES)
  message(STATUS "Setting up examples")

  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${DEAL_II_EXAMPLES_RELDIR}
    COMPONENT examples
    FILES_MATCHING
    #
    # Exclude folder structures: doc, doxygen, CMakeFiles,...
    #
    PATTERN "CMakeFiles*" EXCLUDE
    PATTERN "doc*" EXCLUDE
    #
    # Glob Includes:
    #
    PATTERN "*.cu"
    PATTERN "*.cc"
    PATTERN "*.prm"
    PATTERN "*.inp"
    PATTERN "*.ipynb"
    PATTERN "step*/CMakeLists.txt"
    #
    # Special files:
    #
    PATTERN "output.reference.dat"              # step-39
    PATTERN "postprocess.pl"                    # step-39
    PATTERN "obstacle.pbm"                      # step-42
    PATTERN "example.geo"                       # step-49
    PATTERN "example.msh"                       # step-49
    PATTERN "topography.txt.gz"                 # step-53
    PATTERN "input/initial_mesh_3d.vtk"         # step-54
    PATTERN "input/DTMB-5415_bulbous_bow.iges"  # step-54
    )

  if(DEAL_II_COMPILE_EXAMPLES)
    #
    # Make sure that there are no deprecated functions used in the tutorials.
    #
    strip_flag(DEAL_II_CXX_FLAGS "-Wno-deprecated-declarations")

    #
    # Set up all executables:
    #
    file(GLOB _steps
      ${CMAKE_CURRENT_SOURCE_DIR}/step-*/step-*.cc
      ${CMAKE_CURRENT_SOURCE_DIR}/step-*/step-*.cu)
    foreach(_step ${_steps})
      get_filename_component(_name ${_step} NAME_WE)
      get_filename_component(_directory ${_step} DIRECTORY)

      #
      # Extract dependency information from CMakeLists.txt file.
      #
      set(_setup FALSE)
      if(EXISTS "${_directory}/CMakeLists.txt")
        file(STRINGS "${_directory}/CMakeLists.txt" _dependency_string
          REGEX "^if.*DEAL_II.* # keep in one line$"
          )
        string(REPLACE "if(" "" _dependency_string "${_dependency_string}")
        string(REPLACE ") # keep in one line" "" _dependency_string "${_dependency_string}")
        if("${_dependency_string}" STREQUAL "")
          set(_setup TRUE)
        else()
          # if the dependency string evaluates to TRUE then the example
          # CMakeLists.txt encounters a fatal error - we want the opposite logic
          # here so add a NOT.
          evaluate_expression("
            if(NOT (${_dependency_string}))
              set(_setup TRUE)
            endif()")
        endif()
      endif()

      if(_setup)
        foreach(_build ${DEAL_II_BUILD_TYPES})
          string(TOLOWER ${_build} _build_lowercase)
          set(_target "example_${_name}_${_build_lowercase}")
          string(REPLACE "-" "_" _target "${_target}")
          add_executable(${_target} ${_step})
          insource_setup_target(${_target} ${_build})
          set_target_properties(${_target}
            PROPERTIES
            RUNTIME_OUTPUT_NAME "${_name}.${_build_lowercase}"
            RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
            )
          #
          # In case CMake is instructed to add rpaths to the library and
          # exectuble on installation, make sure that we add an additional
          # rpath to the library location as well:
          #
          if(CMAKE_INSTALL_RPATH_USE_LINK_PATH)
            set_target_properties(${_target}
              PROPERTIES
              INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${DEAL_II_LIBRARY_RELDIR}"
              )
          endif()

          add_dependencies(examples ${_target})
          install(TARGETS ${_target}
            DESTINATION ${DEAL_II_EXAMPLES_RELDIR}/${_name}
            )
        endforeach()

      else()

        message(STATUS "  ${_name} - dependencies not satisfied")
      endif()

    endforeach()

    #
    # Also compile some documentation examples:
    #

    file(GLOB _steps ${CMAKE_CURRENT_SOURCE_DIR}/doxygen/*.cc)
    foreach(_step ${_steps})
      get_filename_component(_name ${_step} NAME_WE)

        foreach(_build ${DEAL_II_BUILD_TYPES})
          string(TOLOWER ${_build} _build_lowercase)
          set(_target "example_${_name}_${_build_lowercase}")
          string(REPLACE "-" "_" _target "${_target}")
          add_executable(${_target} ${_step})
          insource_setup_target(${_target} ${_build})
          set_target_properties(${_target}
            PROPERTIES
            RUNTIME_OUTPUT_NAME "${_name}.${_build_lowercase}"
            RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
            )
        endforeach()
    endforeach()
  endif()

  message(STATUS "Setting up examples - Done")

endif()

=== include/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2022 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# Configure config.h and revision.h
#
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/deal.II/base/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/deal.II/base/config.h
  )
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/deal.II/base/revision.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/deal.II/base/revision.h
  )

#
# Add a rule for how to install the header files:
#
install(DIRECTORY deal.II
  DESTINATION ${DEAL_II_INCLUDE_RELDIR}
  COMPONENT library
  FILES_MATCHING PATTERN "*.h"
  )

#
# and don't forget to install all generated header files, too:
#
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/deal.II
  DESTINATION ${DEAL_II_INCLUDE_RELDIR}
  COMPONENT library
  FILES_MATCHING PATTERN "*.h"
  )

=== source/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

message(STATUS "Setting up library")

#
# This happens surprisingly often:
#
if("${DEAL_II_PACKAGE_NAME}" STREQUAL  "")
  message(FATAL_ERROR
    "\nWrong source directory specified.\n"
    "You pointed cmake to the subdirectory \"source\" instead of the base "
    "directory (the one containing the file \"README.md\"). Make sure that "
    "the path in the cmake invocation does not end in \".../source\". If you "
    "have created a \"build\" subdirectory, the cmake invocation should simply "
    "be of the form:\n"
    "  $ cmake  [...options...]  ../\n"
    "(path not ending in \".../source\")"
    )
endif()

#
# Compile the deal.II library
#

#
# Automatically add the current source and binary directory as include
# directory. The binary directory is needed in order to find the expanded
# .inst include files.
#
set(CMAKE_INCLUDE_CURRENT_DIR true)

#
# List the directories where we have source files. the ones with the longest
# compile jobs come first so that 'make -j N' saturates many processors also
# towards the end of compiling rather than having to wait for one long
# compilation that, because it has been listed last, is started towards the
# end of everything (e.g. numerics/vectors.cc takes several minutes to
# compile...)
#
add_subdirectory(numerics)
add_subdirectory(fe)
add_subdirectory(matrix_free)
add_subdirectory(dofs)
add_subdirectory(lac)
add_subdirectory(base)
add_subdirectory(cgal)
add_subdirectory(gmsh)
add_subdirectory(grid)
add_subdirectory(hp)
add_subdirectory(multigrid)
add_subdirectory(distributed)
add_subdirectory(algorithms)
add_subdirectory(integrators)
add_subdirectory(meshworker)
add_subdirectory(opencascade)
add_subdirectory(particles)
add_subdirectory(differentiation)
add_subdirectory(physics)
add_subdirectory(optimization/rol)
add_subdirectory(non_matching)
add_subdirectory(sundials)
add_subdirectory(trilinos)
add_subdirectory(arborx)

#
# Define a "dealii", i.e., "${DEAL_II_TARGET_NAME}", target that contains
# DEAL_II_CXX_FLAGS[_DEBUG|_RELEASE] and otherwise aliases dealii_debug or
# dealii_release depending on the downstream CMAKE_BUILD_TYPE.
#

add_library(${DEAL_II_TARGET_NAME} INTERFACE)
target_compile_flags(${DEAL_II_TARGET_NAME} INTERFACE
  "$<COMPILE_LANGUAGE:CXX>" "${DEAL_II_CXX_FLAGS}"
  )
target_link_flags(${DEAL_II_TARGET_NAME} INTERFACE "${DEAL_II_LINKER_FLAGS}")

foreach(build ${DEAL_II_BUILD_TYPES})
  string(TOLOWER ${build} build_lowercase)
  if("${build}" MATCHES "DEBUG")
    set(build_camelcase "Debug")
  elseif("${build}" MATCHES "RELEASE")
    set(build_camelcase "Release")
  endif()

  #
  # Combine all ${build} OBJECT targets to a ${build} library:
  #

  set(_object_files "")
  if(NOT BUILD_SHARED_LIBS)
    get_property(_object_targets GLOBAL PROPERTY DEAL_II_OBJECT_TARGETS_${build})
    foreach(_target ${_object_targets})
      list(APPEND _object_files "$<TARGET_OBJECTS:${_target}>")
    endforeach()
  endif()

  add_library(${DEAL_II_TARGET_NAME}_${build_lowercase} dummy.cc ${_object_files})
  add_dependencies(library ${DEAL_II_TARGET_NAME}_${build_lowercase})

  #
  # Add compile flags, definitions and (public) feature (recorded in
  # DEAL_II_TARGETS(|_DEBUG|_RELEASE)).
  #
  populate_target_properties(${DEAL_II_TARGET_NAME}_${build_lowercase} ${build})

  #
  # Record the expected C++ standard as a compile feature. This target
  # property ensures that support for our expected C++ standard is always
  # enabled in client user code irrespective of what compile flags/options
  # they have set.
  #
  target_compile_features(${DEAL_II_TARGET_NAME}_${build_lowercase}
    INTERFACE cxx_std_${CMAKE_CXX_STANDARD}
    )

  if(BUILD_SHARED_LIBS)
    #
    # Add all object targets as private link targets
    #
    get_property(_object_targets GLOBAL PROPERTY DEAL_II_OBJECT_TARGETS_${build})
    target_link_libraries(${DEAL_II_TARGET_NAME}_${build_lowercase}
      PRIVATE ${_object_targets}
      )
  endif()

  set_target_properties(${DEAL_II_TARGET_NAME}_${build_lowercase}
    PROPERTIES
    LINKER_LANGUAGE "CXX"
    VERSION "${DEAL_II_PACKAGE_VERSION}"
    #
    # Sonaming: Well... we just use the version number.
    # No point to wrack one's brain over the question whether a new version of
    # a C++ library is still ABI backwards compatible :-]
    #
    SOVERSION "${DEAL_II_PACKAGE_VERSION}"
    ARCHIVE_OUTPUT_NAME "${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}"
    LIBRARY_OUTPUT_NAME "${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}"
    RUNTIME_OUTPUT_NAME "${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}"
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
    )

  target_compile_flags(${DEAL_II_TARGET_NAME} INTERFACE
    "$<AND:$<CONFIG:${build_camelcase}>,$<COMPILE_LANGUAGE:CXX>>"
    "${DEAL_II_CXX_FLAGS_${build}}"
    )
  target_link_flags(${DEAL_II_TARGET_NAME} INTERFACE
    "$<CONFIG:${build_camelcase}>" "${DEAL_II_LINKER_FLAGS_${build}}"
    )

  if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    set_target_properties(${DEAL_II_TARGET_NAME}_${build_lowercase}
      PROPERTIES
      MACOSX_RPATH OFF
      BUILD_WITH_INSTALL_RPATH OFF
      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${DEAL_II_LIBRARY_RELDIR}"
      )
  endif()

  # Under Windows (MSVC) cmake will always generate multi-configuration
  # projects. When building on the command line with 'cmake --build .',
  # release and debug builds of the library are done with the default 'Debug'
  # configuration. This causes the debug and release .lib to be built inside
  # ./lib/Debug/. This is not very pretty and confuses example/test projects,
  # so we just hard-wire the location here. We only really need to set static
  # lib locations for _DEBUG (no support for dynamic linking, _RELEASE will be
  # ignored), but we do it anyhow.
  if (DEAL_II_MSVC)
    set_target_properties(${DEAL_II_TARGET_NAME}_${build_lowercase}
      PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
      LIBRARY_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
      RUNTIME_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
      ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
      LIBRARY_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
      RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
      )
  endif()

  file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR})
  export(TARGETS ${DEAL_II_TARGET_NAME}_${build_lowercase}
    NAMESPACE "${DEAL_II_TARGET_NAME}::"
    FILE ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Targets.cmake
    APPEND
    )

  install(TARGETS ${DEAL_II_TARGET_NAME}_${build_lowercase}
    COMPONENT library
    EXPORT ${DEAL_II_PROJECT_CONFIG_NAME}Targets
    RUNTIME DESTINATION ${DEAL_II_EXECUTABLE_RELDIR}
    LIBRARY DESTINATION ${DEAL_II_LIBRARY_RELDIR}
    ARCHIVE DESTINATION ${DEAL_II_LIBRARY_RELDIR}
    )

  target_link_libraries(${DEAL_II_TARGET_NAME} INTERFACE
    "$<$<CONFIG:${build_camelcase}>:${DEAL_II_TARGET_NAME}::${DEAL_II_TARGET_NAME}_${build_lowercase}>"
    )
endforeach()

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR})
export(TARGETS ${DEAL_II_TARGET_NAME}
  NAMESPACE "${DEAL_II_TARGET_NAME}::"
  FILE ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Targets.cmake
  APPEND
)

install(TARGETS ${DEAL_II_TARGET_NAME}
  COMPONENT library
  EXPORT ${DEAL_II_PROJECT_CONFIG_NAME}Targets
  RUNTIME DESTINATION ${DEAL_II_EXECUTABLE_RELDIR}
  LIBRARY DESTINATION ${DEAL_II_LIBRARY_RELDIR}
  ARCHIVE DESTINATION ${DEAL_II_LIBRARY_RELDIR}
)

install(EXPORT ${DEAL_II_PROJECT_CONFIG_NAME}Targets
  NAMESPACE "${DEAL_II_TARGET_NAME}::"
  DESTINATION ${DEAL_II_PROJECT_CONFIG_RELDIR}
  COMPONENT library
  )

message(STATUS "Setting up library - Done")

=== tests/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2013 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# Set up the testsuite.
#
# We define toplevel targets:
#    setup_tests    - set up testsuite subprojects
#    prune_tests    - remove all testsuite subprojects
#    test           - run all quick_tests
#

cmake_minimum_required(VERSION 3.13.4)

macro(set_if_empty _variable)
  if("${${_variable}}" STREQUAL "")
    set(${_variable} ${ARGN})
  endif()
endmacro()

set_if_empty(MAKEOPTS $ENV{MAKEOPTS})
set_if_empty(DEAL_II_DIR $ENV{DEAL_II_DIR})

#
# Setup for the case that tests are configured as a stand-alone project:
#

if(NOT DEFINED DEAL_II_HAVE_TESTS_DIRECTORY)
  message(STATUS "This is CMake ${CMAKE_VERSION}")
  message(STATUS "")

  if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "The testsuite cannot be configured in-source. "
      "Please create a separate build directory!"
      )
  endif()

  find_package(deal.II 9.5.0 REQUIRED HINTS ${DEAL_II_DIR})
  deal_ii_initialize_cached_variables()
  project(TESTSUITE CXX)
  set(_options "-DDEAL_II_DIR=${DEAL_II_PATH}")

  file(WRITE ${CMAKE_BINARY_DIR}/detailed.log
    "#        CMAKE_CXX_COMPILER:     ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION} on platform ${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_PROCESSOR}"
    )
endif()

#
# Setup for the case that tests are included via ADD_SUBDIRECTORY from the
# top-level CMake project:
#

if(DEFINED DEAL_II_HAVE_TESTS_DIRECTORY)
  message(STATUS "Setting up testsuite")

  #
  # Write minimalistic CTestTestfile.cmake files to CMAKE_BINARY_DIR:
  #
  file(WRITE ${CMAKE_BINARY_DIR}/CTestTestfile.cmake "subdirs(tests)\n")

  set(_options "-DDEAL_II_DIR=${CMAKE_BINARY_DIR}")
endif()

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake "")

#
# Always undefine the following variables in the setup_tests target:
#
foreach(_var
    DIFF_DIR NUMDIFF_DIR TEST_PICKUP_REGEX TEST_TIME_LIMIT
    TEST_MPI_RANK_LIMIT TEST_THREAD_LIMIT ENABLE_PERFORMANCE_TESTS
    TESTING_ENVIRONMENT
    )
  list(APPEND _options "-U${_var}")
  if(NOT "${${_var}}" STREQUAL "")
    list(APPEND _options "-D${_var}=${${_var}}")
  endif()
endforeach()

#
# Find all testsuite subprojects, i.e., every directory that contains a
# CMakeLists.txt file.
#
set(_categories)
file(GLOB _dirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/*
  )
foreach(_dir ${_dirs})
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${_dir}/CMakeLists.txt)
    list(APPEND _categories ${_dir})
  endif()
endforeach()

#
# Custom targets for the testsuite:
#

# Setup tests:
add_custom_target(setup_tests)

# Remove all tests:
add_custom_target(prune_tests)

foreach(_category ${_categories})
  set(_category_dir ${CMAKE_CURRENT_SOURCE_DIR}/${_category})

  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_category})

  if(DEAL_II_MSVC)
    set(_command ${CMAKE_COMMAND} -G${CMAKE_GENERATOR} ${_options} ${_category_dir})
  else()
    # Do not pass the generator with -G so that we use make instead of ninja
    # for the test projects. This is because calling ninja several times in
    # parallel for the same project will break the configuration.
    set(_command ${CMAKE_COMMAND} ${_options} ${_category_dir} > /dev/null)
  endif()

  add_custom_target(setup_tests_${_category}
    COMMAND ${_command}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_category}
    COMMENT "Processing tests/${_category}"
    )
  add_dependencies(setup_tests setup_tests_${_category})

  add_custom_target(prune_tests_${_category}
    COMMAND ${CMAKE_COMMAND} -E remove_directory
      ${CMAKE_CURRENT_BINARY_DIR}/${_category}
    COMMAND ${CMAKE_COMMAND} -E make_directory
      ${CMAKE_CURRENT_BINARY_DIR}/${_category}
    COMMENT "Processing tests/${_category}"
    )
  add_dependencies(prune_tests prune_tests_${_category})

  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake
    "subdirs(${_category})\n"
    )
endforeach()


if(DEFINED DEAL_II_HAVE_TESTS_DIRECTORY)

  #
  # Define a top-level "test" target that runs our quick tests wrapper.
  #

  # Use the first available build type (this prefers debug mode if available):
  list(GET DEAL_II_BUILD_TYPES 0 _my_build)
  add_custom_target(test
    COMMAND ${CMAKE_COMMAND} -DCMAKE_BUILD_TYPE=${_my_build} -P ${CMAKE_CURRENT_SOURCE_DIR}/run_quick_tests.cmake
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Running quicktests..."
    )

  # Depend on the library targets (to ensure that deal.II is actually
  # compiled), as well as on the setup_tests_quick_tests target to ensure
  # that quick tests are actually available.
  add_dependencies(test setup_tests_quick_tests)
  foreach(_build ${DEAL_II_BUILD_TYPES})
    string(TOLOWER ${_build} _build_lowercase)
    add_dependencies(test ${DEAL_II_TARGET_NAME}_${_build_lowercase})
  endforeach()

  #
  # Add a dummy target to make files known to IDEs like qtcreator
  #

  file(GLOB _misc
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/*/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/*/*.h
    )
  add_custom_target(testsuite SOURCES ${_misc})

  message(STATUS "Setting up testsuite - Done")
endif()

=== cmake/config/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# This file sets up the project configuration consisting of
#
#   deal.IIConfig.cmake
#   deal.IIVersionConfig.cmake
#
# We support two configurations out of which deal.II can be used - directly
# from the build directory or after installation. So we have to prepare
# two distinct setups.
#

message(STATUS "Setting up project configuration")

#
# Configure the template-arguments file
#
configure_file( # for binary dir:
  ${CMAKE_CURRENT_SOURCE_DIR}/template-arguments.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/template-arguments
  )


########################################################################
#                                                                      #
#                   Setup and install cmake macros:                    #
#                                                                      #
########################################################################

set(_macros
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_add_test.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_initialize_cached_variables.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_invoke_autopilot.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_pickup_tests.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_query_git_information.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_setup_target.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_shell_escape_option_groups.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_target_compile_flags.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_target_link_flags.cmake
  )
file(COPY ${_macros}
  DESTINATION ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/macros
  )
install(FILES ${_macros}
  DESTINATION ${DEAL_II_SHARE_RELDIR}/macros
  COMPONENT library
  )


########################################################################
#                                                                      #
#        Configure and install the cmake project configuration:        #
#                                                                      #
########################################################################

#
# Populate a bunch of CONFIG_* variables with useful information:
#

foreach(_build ${DEAL_II_BUILD_TYPES})
  string(TOLOWER ${_build} _build_lowercase)

  set(_keyword)
  if("${CMAKE_BUILD_TYPE}" STREQUAL "DebugRelease")
    if(_build MATCHES DEBUG)
      set(_keyword "debug")
    else()
      set(_keyword "optimized")
    endif()
  endif()

  set(CONFIG_TARGET_${_build} ${DEAL_II_TARGET_NAME}::${DEAL_II_TARGET_NAME}_${_build_lowercase})
  list(APPEND CONFIG_TARGET ${_keyword} \${DEAL_II_TARGET_${_build}})
endforeach()

#
# For binary dir:
#

set(CONFIG_BUILD_DIR TRUE)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  @ONLY
  )
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/ConfigVersion.cmake.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  @ONLY
  )

#
# For installation:
#

set(CONFIG_BUILD_DIR FALSE)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  @ONLY
  )
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/ConfigVersion.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  @ONLY
  )
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  DESTINATION ${DEAL_II_PROJECT_CONFIG_RELDIR}
  COMPONENT library
  )

#
# Append feature configuration to all configuration files:
#

set(_files
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  )
foreach(_file ${_files})
  file(APPEND ${_file} "\n\n#\n# Feature configuration:\n#\n\n")
  file(APPEND ${_file}
    "set(DEAL_II_WITH_CXX11 ON)\n"
    "set(DEAL_II_WITH_CXX14 ON)\n"
    "set(DEAL_II_WITH_CXX17 ${DEAL_II_HAVE_CXX17})\n"
    "set(DEAL_II_WITH_THREADS ON)\n"
    )
endforeach()

get_cmake_property(_res VARIABLES)
foreach(_var ${_res})
  if(_var MATCHES "DEAL_II_.*(WITH|FEATURE.*BUNDLED)")
    list(APPEND _additional_config_variables ${_var})
  endif()
endforeach()

set(_deal_ii_features_sorted ${DEAL_II_FEATURES})
list(SORT _deal_ii_features_sorted)
foreach(_name ${_deal_ii_features_sorted})
  set(_var DEAL_II_WITH_${_name})

  foreach(_file ${_files})
    file(APPEND ${_file} "set(${_var} ${${_var}})\n")
    #
    # Do not pollute deal.IIConfig.cmake with package details of
    # unconfigured features.
    #
    if(${_var})
      if(NOT "${${_name}_VERSION}" STREQUAL "")
        file(APPEND ${_file}
          "set(DEAL_II_${_name}_VERSION \"${${_name}_VERSION}\")\n"
          )
      endif()

      foreach(_additional ${_additional_config_variables})
        if(_additional MATCHES "(DEAL_II_${_name}_WITH|DEAL_II_FEATURE_${_name})")
          file(APPEND ${_file} "set(${_additional} ${${_additional}})\n")
        endif()
      endforeach()
    endif()
  endforeach()
endforeach()

#
# Job's done.
#

message(STATUS "Setting up project configuration - Done")

=== cmake/scripts/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2022 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

add_executable(expand_instantiations_exe expand_instantiations.cc)

#
# We run into a bug when compiling expand_instantiations with
# -fuse-ld=gold -pthreads, see https://github.com/dealii/dealii/issues/1798
# Work around this by stripping -fuse-ld=gold out of the build flags
# for the script. This does little harm because linking this one file
# is so exceedingly cheap that there is no speed difference between
# using gold or the old BFD ld linker.
#
# If we are on a system where -fuse-ld=gold simply isn't part of the
# linker flag, filtering this one command out of the list of flags
# does not harm either.
#
string(REPLACE "-fuse-ld=gold" "" _expand_instantiations_link_flags "${DEAL_II_LINKER_FLAGS}" )

set_target_properties(expand_instantiations_exe PROPERTIES
  LINK_FLAGS "${_expand_instantiations_link_flags}"
  LINKER_LANGUAGE "CXX"
  COMPILE_DEFINITIONS "${DEAL_II_DEFINITIONS}"
  COMPILE_FLAGS "${DEAL_II_CXX_FLAGS}"
  OUTPUT_NAME expand_instantiations
  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}
  )

if (DEAL_II_MSVC)
  set_target_properties(expand_instantiations_exe PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
    RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
    )
endif()

set(_scripts
  ${CMAKE_CURRENT_SOURCE_DIR}/normalize.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/run_test.cmake
  ${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/get_closest_tag.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/get_latest_tag.sh
  )
file(COPY ${_scripts}
  DESTINATION ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/scripts
  )
install(FILES ${_scripts}
  DESTINATION ${DEAL_II_SHARE_RELDIR}/scripts
  COMPONENT library
  )

=== contrib/python-bindings/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2016 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

if(DEAL_II_COMPONENT_PYTHON_BINDINGS)

  message(STATUS "")
  message(STATUS "Setting up python bindings")

  #
  # Find Python:
  #
  find_package(Python3)
  set(PYTHON_VERSION_MAJOR ${Python3_VERSION_MAJOR})
  set(PYTHON_VERSION_MINOR ${Python3_VERSION_MINOR})
  set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
  include(FindPythonLibs)

  if(DEAL_II_FEATURE_BOOST_BUNDLED_CONFIGURED)
    message(FATAL_ERROR
      "DEAL_II_COMPONENT_PYTHON_BINDINGS has unmet configuration requirements: "
      "Python bindings require an external boost library, but deal.II was "
      "configured with bundled boost."
      )
  endif()

  #
  # As of 1.67, boost requires specifying the suffix for the python
  # component manually.
  #
  unset(Boost_FOUND)
  # On case-insensitive file systems, FindBOOST.cmake and FindBoost.cmake are indistinguishable.
  # Make sure FindBoost.cmake from CMake installation is found.
  list(REMOVE_ITEM CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/)
  set(Boost_USE_DEBUG_RUNTIME FALSE)
  if(${BOOST_VERSION} VERSION_LESS 1.67)
    find_package(Boost 1.59 COMPONENTS python REQUIRED)
  else()
    find_package(Boost 1.67 COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR} REQUIRED)
  endif()
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/)

  if(NOT Boost_FOUND)
    message(FATAL_ERROR
      "DEAL_II_COMPONENT_PYTHON_BINDINGS has unmet configuration requirements: "
      "The external boost library does not provide Boost.Python"
      )
  endif()

  #
  # FIXME: Once finalized, reconsider moving this definitions into
  # cmake/setup_dealii.cmake
  #
  # General information about deal.II:
  #
  #     PYTHON_BINDINGS_BASE_NAME       *)
  #     PYTHON_BINDINGS_DEBUG_NAME      *)
  #     PYTHON_BINDINGS_RELEASE_NAME    *)
  #
  # Information about paths, install locations and names:
  #
  #     DEAL_II_PYTHON_RELDIR           *) **)
  #
  # *)  Can be overwritten by the command line via -D<...>
  # **) We do a best effort guess on site-packages location...
  #

  set_if_empty(PYTHON_BINDINGS_BASE_NAME "PyDealII")
  set_if_empty(PYTHON_BINDINGS_DEBUG_NAME "Debug")
  set_if_empty(PYTHON_BINDINGS_RELEASE_NAME "Release")

  set_if_empty(DEAL_II_PYTHON_RELDIR
    "${DEAL_II_LIBRARY_RELDIR}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/${PYTHON_BINDINGS_BASE_NAME}"
    )

  add_subdirectory(source)

  add_subdirectory(tests)

  message(STATUS "Setting up python bindings - Done")
  message(STATUS "")

endif()

=== contrib/utilities/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2018 - 2022 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# At the present time we only install one script from this directory.
#

set(_scripts
  ${CMAKE_CURRENT_SOURCE_DIR}/indent.py
  )
file(COPY ${_scripts}
  DESTINATION ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/scripts
  )
install(FILES ${_scripts}
  DESTINATION ${DEAL_II_SHARE_RELDIR}/scripts
  COMPONENT library
  )

=== doc/doxygen/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2023 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

#
# Generate the source documentation via doxygen:
#

find_package(Perl)
find_package(Doxygen)

#
# Do we have all necessary dependencies?
#
if(NOT PERL_FOUND)
  message(FATAL_ERROR
    "Could not find a perl installation which is required for building the documentation"
    )
endif()
if(NOT DOXYGEN_FOUND)
  message(FATAL_ERROR
    "Could not find doxygen which is required for building the documentation"
    )
else()
  message(STATUS "Using doxygen version ${DOXYGEN_VERSION}")
endif()


########################################################################
#
# Process the tutorial and code-gallery files into inputs for doxygen
#
########################################################################

add_subdirectory(tutorial)
add_subdirectory(code-gallery)


########################################################################
#
# Set up all of the other input pieces we want to give to doxygen
#
########################################################################

#
# Prepare auxiliary files for doxygen:
#
if(DEAL_II_DOXYGEN_USE_MATHJAX)
  set(_use_mathjax YES)
  if(NOT DEAL_II_DOXYGEN_USE_ONLINE_MATHJAX)
    deal_ii_find_path(MATHJAX_PATH MathJax.js
      PATHS ${MATHJAX_ROOT}
      $ENV{MATHJAX_ROOT}
      "${CMAKE_PREFIX_PATH}/share/javascript/mathjax"
      "${CMAKE_INSTALL_DATADIR}/javascript/mathjax"
      "/usr/share/javascript/mathjax"
      "/usr/share/yelp/mathjax"
      DOC "Root path of MathJax.js"
      )
    if(MATHJAX_PATH MATCHES "MATHJAX_PATH-NOTFOUND")
      message(FATAL_ERROR "MathJax was not found.")
    endif()
  endif()
  if(MATHJAX_PATH AND NOT DEAL_II_DOXYGEN_USE_ONLINE_MATHJAX)
    set(_mathjax_relpath ${MATHJAX_PATH})
    message(STATUS "Using local MathJax: " ${MATHJAX_PATH})
  else()
    set(_mathjax_relpath "https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/")
    message(STATUS "Using web-based MathJax: " ${_mathjax_relpath})
  endif()
else()
  set(_use_mathjax NO)
endif()


# Collect where the build system will write the .inst files after
# expansion from the .inst.in files. We need this because we let
# doxygen read the .cc files and they #include the .inst files.
#
# To get at this, find all of the .inst.in files, strip all but the
# directory name under $CMAKE_SOURCE_DIR/source, and then prepend
# the build directory to it
#
# See options.dox.in where ${_inst_in_dirs} is later added to INCLUDE_PATH.
file(GLOB _inst_in_files
     "${CMAKE_SOURCE_DIR}/source/*/*.inst.in")
string(REPLACE "${CMAKE_SOURCE_DIR}/source/" "" _inst_in_dirs_x "${_inst_in_files}")
string(REGEX REPLACE "/[a-zA-Z0-9_\\.]*.inst.in" "/" _inst_in_dirs_y "${_inst_in_dirs_x}")
list(REMOVE_DUPLICATES _inst_in_dirs_y)
set(_inst_in_dirs "")
foreach (_dir ${_inst_in_dirs_y})
  set(_inst_in_dirs "${_inst_in_dirs} ${CMAKE_BINARY_DIR}/source/${_dir}")
endforeach()

message(STATUS "Additional doxygen include paths: ${_inst_in_dirs}")

# make sure doxygen sees the extra.sty stylefile:
set(_extra_packages "${CMAKE_CURRENT_SOURCE_DIR}/extra")

# Generate the input files for doxygen using template .in files in which
# we have to substitute some CMake variables
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/options.dox.in
  ${CMAKE_CURRENT_BINARY_DIR}/options.dox
  )

# Figure out the last copyright date of any of the deal.II source
# files. We will use this then to set the copyright date of the
# doxygen-generated HTML files.
set(_last_year "1997")
file(GLOB _source_files
     "${CMAKE_SOURCE_DIR}/source/*/*.cc"
     "${CMAKE_SOURCE_DIR}/include/deal.II/*/*.h"
     "${CMAKE_SOURCE_DIR}/examples/*/*.cc")
foreach (_source ${_source_files})
  file(READ "${_source}" contents)
  string(REGEX MATCH "Copyright .C. +([0-9]+ - )?([0-9]+)" _copyright "${contents}")
  if (NOT "${_copyright}" STREQUAL "")
    string(REGEX MATCH "[0-9]+\$" _year "${_copyright}")

    if (NOT _year STREQUAL ""   AND   _year GREATER _last_year)
      set (_last_year "${_year}")
    endif()
  endif()
endforeach()
set(DEAL_II_PACKAGE_YEAR ${_last_year})
message(STATUS "doxygen output will have copyright date ${_last_year}")


# Put the copyright year into the correct files
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/scripts/mod_header.pl.in
  ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/scripts/mod_footer.pl.in
  ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl
  )


#
# Generate header, footer and style files for doxygen.
#
# A bug in (at least) doxygen 1.8.12 required that these files already exist
# if they are listed in the options.dox file, even though the -w command is
# specifically intended to create them. See
#    https://bugzilla.gnome.org/show_bug.cgi?id=771606
# To work around this, do a 'touch' operation on them first to ensure they're
# there before we call "doxygen -w".
#
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/header.html
         ${CMAKE_CURRENT_BINARY_DIR}/footer.html
  COMMAND ${CMAKE_COMMAND} -E touch header.html
  COMMAND ${CMAKE_COMMAND} -E touch footer.html
  COMMAND ${DOXYGEN_EXECUTABLE} -w html header.html footer.html style.css options.dox
  COMMAND ${PERL_EXECUTABLE} -pi ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl header.html
  COMMAND ${PERL_EXECUTABLE} -pi ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl footer.html
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl
    ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl
  )

#
# Finalize the doxygen configuration:
#

set(_doxygen_input
  ${CMAKE_CURRENT_SOURCE_DIR}/headers/
)

file(GLOB _changelog_files
  ${CMAKE_SOURCE_DIR}/doc/news/*.h
  )

list(APPEND _doxygen_input
  ${CMAKE_SOURCE_DIR}/include/
  ${CMAKE_SOURCE_DIR}/source/
  ${CMAKE_BINARY_DIR}/include/
  ${_changelog_files}
  ${CMAKE_BINARY_DIR}/doc/news/
  ${CMAKE_CURRENT_BINARY_DIR}/tutorial/tutorial.h
  )

# Add other directories in which to find images
set(_doxygen_image_path
  ${CMAKE_CURRENT_SOURCE_DIR}/images
  )

file(GLOB _doxygen_depend
  ${CMAKE_CURRENT_SOURCE_DIR}/headers/*.h
  ${CMAKE_SOURCE_DIR}/doc/news/*.h
  ${CMAKE_SOURCE_DIR}/include/deal.II/**/*.h
  )

# Specifically list a few files that are generated by
# other cmake targets as dependencies for doxygen, to ensure
# that they are in fact generated. This would not work if they
# are captured via a GLOB since they may not exist (and so not
# be captured via the GLOB) at the time cmake runs
list(APPEND _doxygen_depend
  ${CMAKE_BINARY_DIR}/include/deal.II/base/config.h
  ${CMAKE_CURRENT_BINARY_DIR}/tutorial/tutorial.h
  )

# Add the changelog (a CMake custom target) as a dependency for doxygen too
list(APPEND _doxygen_depend changelog)

# find all tutorial programs so we can add dependencies as appropriate
file(GLOB _deal_ii_steps
  ${CMAKE_SOURCE_DIR}/examples/step-*
  )
foreach(_step ${_deal_ii_steps})
  get_filename_component(_step "${_step}" NAME)
  list(APPEND _doxygen_depend
    ${CMAKE_CURRENT_BINARY_DIR}/tutorial/${_step}.h
    )
  list(APPEND _doxygen_input
    ${CMAKE_CURRENT_BINARY_DIR}/tutorial/${_step}.h
    )
endforeach()

# Also find all code gallery programs (if available) for the same reason.
# The logic here follows the same as in code-gallery/CMakeLists.txt
set_if_empty(DEAL_II_CODE_GALLERY_DIRECTORY ${CMAKE_SOURCE_DIR}/code-gallery)
if (EXISTS ${DEAL_II_CODE_GALLERY_DIRECTORY}/README.md)
  file(GLOB _code_gallery_names
       "${DEAL_II_CODE_GALLERY_DIRECTORY}/*/doc/author")
  string(REGEX REPLACE "/+doc/+author" "" _code_gallery_names "${_code_gallery_names}")

  foreach(_step ${_code_gallery_names})
    get_filename_component(_step "${_step}" NAME)

    list(APPEND _doxygen_depend
      ${CMAKE_CURRENT_BINARY_DIR}/code-gallery/${_step}.h
      )
    list(APPEND _doxygen_input
      ${CMAKE_CURRENT_BINARY_DIR}/code-gallery/${_step}.h
      )
  endforeach()
endif()


# always make the doxygen run depend on the code-gallery.h file
# (whether generated from the code gallery or copied from
# no-code-gallery.h; both happen in code-gallery/CMakeLists.txt)
list(APPEND _doxygen_input
  ${CMAKE_CURRENT_BINARY_DIR}/code-gallery/code-gallery.h
)
list(APPEND _doxygen_depend
  ${CMAKE_CURRENT_BINARY_DIR}/code-gallery/code-gallery.h
)


to_string(_doxygen_image_path_string ${_doxygen_image_path})
to_string(_doxygen_input_string ${_doxygen_input})

file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/options.dox"
  "
  INPUT=${_doxygen_input_string}
  IMAGE_PATH=${_doxygen_image_path_string}
  "
  )

# If we use a reasonably modern doxygen version, make sure it is run in parallel
if(NOT (${DOXYGEN_VERSION} VERSION_LESS 1.9))
  file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/options.dox"
    "
    NUM_PROC_THREADS       = 0
    DOT_NUM_THREADS        = 0
    "
    )
  message(STATUS "Letting doxygen run with multiple threads")
endif()


# doxygen version 1.9.1 can not correctly parse C++20-style 'requires'
# clauses and just drops certain classes and shows documentation for
# DEAL_II_CXX20_REQUIRES instead. 1.9.7 gets this right, but has other
# bugs. It's unclear for versions inbetween. Err on the safe side, and
# only make them visible to doxygen if we have at least 1.9.8.
#
# For the 9.5 release branch, we had some trouble with this logic. Simply
# disable parsing 'requires' clauses unconditionally on the release branch.
file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/options.dox"
  "
  PREDEFINED += DEAL_II_DOXYGEN_DO_NOT_PARSE_REQUIRES_CLAUSES=1
  PREDEFINED += DEAL_II_CXX20_REQUIRES(x)=
  "
  )



########################################################################
#
# And, finally, call doxygen:
#
########################################################################

add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/doxygen.log
  COMMAND ${DOXYGEN_EXECUTABLE}
    ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    > ${CMAKE_BINARY_DIR}/doxygen.log 2>&1 # *pssst*
    || ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/doxygen.log ${CMAKE_BINARY_DIR}/doxygen.err
  COMMAND ${PERL_EXECUTABLE}
  ARGS
    ${CMAKE_CURRENT_SOURCE_DIR}/scripts/set_canonical_doxygen.pl
  COMMAND ${CMAKE_COMMAND} -E echo "-- Documentation is available at ${CMAKE_CURRENT_BINARY_DIR}/deal.II/index.html"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS
    tutorial
    code-gallery
    ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    ${CMAKE_CURRENT_BINARY_DIR}/header.html
    ${CMAKE_CURRENT_BINARY_DIR}/footer.html
    ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/scripts/filter.pl
    ${_doxygen_depend}
    expand_all_instantiations
  COMMENT "Generating documentation via doxygen."
  VERBATIM
  )
add_custom_target(doxygen ALL
  DEPENDS ${CMAKE_BINARY_DIR}/doxygen.log
  )
add_dependencies(documentation doxygen)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/deal.tag
  DESTINATION ${DEAL_II_DOCHTML_RELDIR}/doxygen
  COMPONENT documentation
  )

install(FILES
  ${CMAKE_SOURCE_DIR}/doc/deal.ico
  ${CMAKE_SOURCE_DIR}/doc/doxygen/custom.js
  DESTINATION ${DEAL_II_DOCHTML_RELDIR}/doxygen/deal.II
  COMPONENT documentation
  )

install(DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}/deal.II
  DESTINATION ${DEAL_II_DOCHTML_RELDIR}/doxygen
  COMPONENT documentation
  )

=== doc/news/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2016 - 2022 by the deal.II Authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------


#
# Set up all necessary bits for the changelog generation
#
if(DEAL_II_COMPONENT_DOCUMENTATION)

  message(STATUS "")
  message(STATUS "Setting up changelog generation")

  #
  # Generate changes.h.
  #
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/changes.h
    COMMAND ${CMAKE_COMMAND} -DOUTPUT_FILE=${CMAKE_CURRENT_BINARY_DIR}/changes.h
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/changes/create_changes_h.cmake
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/changes
    DEPENDS
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/header
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/header_incompatibilities
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/header_major
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/header_minor
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/footer
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/major
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/minor
      ${CMAKE_CURRENT_SOURCE_DIR}/changes/incompatibilities
  )

  add_custom_target(changelog ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/changes.h
  )

  add_dependencies(documentation changelog)

endif()

=== debian/changelog ===
deal.ii (9.5.1-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:52:06 +0000

deal.ii (9.5.1-2build2) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:21:08 +0000

deal.ii (9.5.1-2build1) noble; urgency=medium

  * Rebuild against latest gmsh

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 15:30:51 -0500

deal.ii (9.5.1-2) unstable; urgency=medium

  [ Matthias Maier ]
  * Fix compilation with boost-1.83 on ppc64el,
    upstream: https://github.com/dealii/dealii/pull/16434
    (Closes: #1059349)

  [ Graham Inggs ]
  * Update debian/watch

 -- Matthias Maier <tamiko+DEBIAN@43-1.org>  Tue, 09 Jan 2024 13:32:19 +0000

deal.ii (9.5.1-1) unstable; urgency=medium

  * New upstream release
  * update patches
  * Disable dh_dwz

 -- Matthias Maier <tamiko+DEBIAN@43-1.org>  Fri, 15 Sep 2023 12:06:30 +0000

=== debian/control ===
Source: deal.ii
Section: libs
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>,
           Graham Inggs <ginggs@debian.org>
Vcs-Browser: https://salsa.debian.org/science-team/deal.ii
Vcs-Git: https://salsa.debian.org/science-team/deal.ii.git
Homepage: http://www.dealii.org/
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               gmsh,
               graphviz,
               libadolc-dev (>= 2.6.4),
               libarpack2-dev,
               libassimp-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcgal-dev,
               libgmsh-dev,
               libgsl-dev,
               libhdf5-dev,
               libhdf5-mpi-dev,
               liblapack-dev,
               libmetis-dev,
               libmuparser-dev,
               libocct-data-exchange-dev,
               libocct-foundation-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libp4est-dev (>= 2.0),
               libscalapack-mpi-dev,
               libsuitesparse-dev,
               libsundials-dev (>= 5.7.0),
               libtbb-dev,
               mpi-default-dev,
               petsc-dev,
               python3-minimal:native,
               slepc-dev,
               trilinos-all-dev,
               zlib1g-dev

Package: libdeal.ii-dev
Section: libdevel
Architecture: any
Depends: libadolc-dev (>= 2.6.4),
         libarpack2-dev,
         libassimp-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-serialization-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libcgal-dev,
         libdeal.ii-9.5.1 (= ${binary:Version}),
         libgmsh-dev,
         libgsl-dev,
         libhdf5-dev,
         libhdf5-mpi-dev,
         liblapack-dev,
         libmetis-dev,
         libmuparser-dev,
         libocct-data-exchange-dev,
         libocct-foundation-dev,
         libocct-ocaf-dev,
         libocct-visualization-dev,
         libp4est-dev (>= 2.0),
         libscalapack-mpi-dev,
         libsuitesparse-dev,
         libsundials-dev (>= 5.7.0),
         libtbb-dev,
         mpi-default-dev,
         petsc-dev,
         slepc-dev,
         trilinos-all-dev,
         zlib1g-dev,
         ${misc:Depends}
Recommends: cmake, g++, numdiff
Description: Differential Equations Analysis Library - development files
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the development files.

Package: libdeal.ii-9.5.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gmsh
Pre-Depends: ${misc:Pre-Depends}
Description: Finite Element Differential Equations Analysis Library
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the shared libraries.

Package: libdeal.ii-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: fonts-mathjax-extras, libjs-mathjax, ${misc:Depends}
Description: Differential Equations Analysis Library - html doc. and examples
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#! /usr/bin/make -f

export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_rmaps_base_oversubscribe=1

ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
CONFIGURE_LINKER_FLAGS=-DDEAL_II_LINKER_FLAGS="-Wl,-Bsymbolic-functions"
endif

%:
	dh $@

# The following (optional) dependencies are missing because they are not
# packaged in debian:
#   arborx (https://github.com/arborx/ArborX)
#   ginkgo (https://ginkgo-project.github.io/)
#   symengine (https://github.com/sympy/symengine)
override_dh_auto_configure:
	dh_auto_configure -- \
	-DDEAL_II_CXX_FLAGS="-std=c++17 -Wno-nonnull-compare -Wno-address" \
	$(CONFIGURE_LINKER_FLAGS) \
	-DCMAKE_PREFIX_PATH="/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi;/usr/include/hdf5/openmpi" \
	-DCMAKE_BUILD_TYPE=DebugRelease \
	-DDEAL_II_ALLOW_AUTODETECTION=OFF \
	-DDEAL_II_ALLOW_BUNDLED=OFF \
	-DDEAL_II_ALLOW_PLATFORM_INTROSPECTION=OFF \
	-DDEAL_II_COMPILE_EXAMPLES=OFF \
	-DDEAL_II_COMPONENT_DOCUMENTATION=ON \
	-DDEAL_II_DOXYGEN_USE_MATHJAX=ON \
	-DDEAL_II_DOXYGEN_USE_ONLINE_MATHJAX=OFF \
	-DMATHJAX_PATH="/usr/share/javascript/mathjax" \
	-DDEAL_II_COMPONENT_EXAMPLES=ON \
	-DDEAL_II_HAVE_FP_EXCEPTIONS=FALSE \
	-DDEAL_II_WITH_ADOLC=ON \
	-DDEAL_II_WITH_ARPACK=ON \
	-DDEAL_II_WITH_ASSIMP=ON \
	-DDEAL_II_WITH_BOOST=ON \
	-DDEAL_II_WITH_CGAL=ON \
	-DDEAL_II_WITH_COMPLEX_VALUES=ON \
	-DDEAL_II_WITH_GMSH=ON \
	-DDEAL_II_WITH_GSL=ON \
	-DDEAL_II_WITH_HDF5=ON \
	-DDEAL_II_WITH_KOKKOS=ON \
	-DDEAL_II_WITH_LAPACK=ON \
	-DDEAL_II_WITH_METIS=ON \
	-DDEAL_II_WITH_MPI=ON \
	-DDEAL_II_WITH_MUPARSER=ON \
	-DDEAL_II_WITH_OPENCASCADE=ON \
	-DDEAL_II_WITH_P4EST=ON \
	-DDEAL_II_WITH_PETSC=ON \
	-DDEAL_II_WITH_SCALAPACK=ON \
	-DDEAL_II_WITH_SLEPC=ON \
	-DDEAL_II_WITH_SUNDIALS=ON \
	-DDEAL_II_WITH_TBB=ON \
	-DDEAL_II_WITH_TRILINOS=ON \
	-DDEAL_II_WITH_UMFPACK=ON \
	-DDEAL_II_WITH_ZLIB=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	-DDEAL_II_BASE_NAME="deal.ii" \
	-DDEAL_II_DOCHTML_RELDIR=share/doc/libdeal.ii-doc/html \
	-DDEAL_II_DOCREADME_RELDIR=share/doc/libdeal.ii-doc \
	-DDEAL_II_EXAMPLES_RELDIR=share/doc/libdeal.ii-doc/examples \
	-DDEAL_II_LIBRARY_RELDIR=lib/$(DEB_HOST_MULTIARCH) \
	-DDEAL_II_PROJECT_CONFIG_RELDIR=share/cmake/deal.II \
	-DDEAL_II_SHARE_RELDIR=share/deal.ii/

override_dh_auto_test:
	dh_auto_test --max-parallel=1

TMP_DOC := debian/tmp/usr/share/doc/libdeal.ii-doc
override_dh_auto_install:
	dh_auto_install
	# Copy over all external html resources:
	cp -r doc/doxygen/deal.II/images $(TMP_DOC)/html/doxygen/deal.II/
	# Replace links external deal.II html resources by local links:
	sed -i 's#"https\?://www.dealii.org/images/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html \
		$(TMP_DOC)/html/doxygen/deal.II/namespaceGridGenerator_1_1Airfoil.html
	# Replace zenodo links:
	sed -i -e 's#"https://zenodo.org/badge/DOI/10.5281/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html
	sed -i -e 's#"https://upload.wikimedia.org/wikipedia/commons/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/group_*.html
	# Remove external links to the W3C validator icon:
	find $(TMP_DOC)/html \
		-type f -name '*.html' -exec sed -i 's#\(<img.*w3.org.*\)</a>#</a>#' {} \;
	# Remove superfluous license file
	rm $(TMP_DOC)/LICENSE.md

override_dh_compress:
	# Do not compress example source code, and icons:
	dh_compress -X.cc -X.ico

override_dh_dwz:
	

VERSION := 9.5.1
get-orig-source:
	wget --no-clobber -O deal.ii-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION).tar.gz
	wget --no-clobber -O deal.ii-doc-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION)-offline_documentation.tar.gz
	mkdir deal.ii-$(VERSION)
	tar --strip-components=1 -C deal.ii-$(VERSION) -xzf deal.ii-$(VERSION).tar.gz
	mkdir -p deal.ii-$(VERSION)/doc/doxygen/deal.II
	tar -C deal.ii-$(VERSION) -xzf deal.ii-doc-$(VERSION).tar.gz doc/doxygen/deal.II/images
	set -e; cd deal.ii-$(VERSION); \
		rm -rf bundled
	tar -cJf deal.ii_$(VERSION).orig.tar.xz deal.ii-$(VERSION)
	rm -rf deal.ii-$(VERSION)
